<?php
// Fusion Core Ajax Helper Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: ajaxhelpers-misc.inc.php 18 2010-07-08 20:21:34Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');
	

////////////////////////////////////////////////////////////////////////
// STATUSAJAX FUNCTIONS
////////////////////////////////////////////////////////////////////////
	
function fusioncore_ajax_get_server_tactical_overview_html($args=null){
	global $lstr;
	
	$sid=grab_array_var($args,"id");
	
	// get saved credentials
	$sc=get_option("server_credentials");
	if($sc==null)
		$sc=array();
	else
		$sc=unserialize($sc);	
	
	$output='';
	
	//$output.="SID=$sid<BR>";
	//$output.=serialize($args);
	
	// get credentials
	$username=grab_array_var($sc[$sid],"username");
	$password=grab_array_var($sc[$sid],"password");
	
	// we dont' have credentials
	if(!have_value($username) || !have_value($password)){
		$output.='<span class="tacservernocredentials"><img src="'.theme_image("critical_small.png").'"> You have not defined authentication credentials for this server.  <a href="'.get_base_url().'config/" target="_top">Define them now</a>.</a>';
		}
	else{
	
		$sinfo=get_server_info($sid);
	
		switch($sinfo["type"]){
			case "nagiosxi":
				$output.=get_nagiosxi_tac_overview_data($sid,$username,$password);
				break;
			case "nagioscore":
				$output.=get_nagioscore_tac_overview_data($sid,$username,$password);
				break;
			}
			
		
		/*
		$output.='
		<table class="infotable">
		<thead>
		<tr><th>&nbsp;</th></tr>
		</thead>
		<tbody>
		';
		
			
		$output.='
		</tbody>
		</table>
		';
		*/
		}
			
	$output.='
	<div class="ajax_date">Last Updated: '.get_datetime_string(time()).'</div>
	';

	return $output;
	}

function get_nagioscore_tac_overview_data($sid,$username,$password){
	
	$output="";
	

	///////////////////////////////////////
	// get tac overview data
	///////////////////////////////////////
	$tac_data=array();
	get_server_data($sid,$username,$password,"tac",$tac_data);
	
	// check for errors...
	$error=false;
	
	// check for timeout
	if($tac_data["timeout"]==true){
		$output.='<span class="tacservertimeout"><img src="'.theme_image("critical_small.png").'"> A timeout occurred while attempting to contact the server.</span>';
		$error=true;
		}
		
	// check for auth/404 errors
	if($error==false){
		if($tac_data["http_code"]==401){
			$output.='<span class="tacserverautherror"><img src="'.theme_image("critical_small.png").'"> Failed to authenticate to server.  <a href="'.get_base_url().'config/" target="_top">Change credentials</a>.</span>';
			$error=true;
			}
		if($tac_data["http_code"]==404){
			$output.='<span class="tacservernotfound"><img src="'.theme_image("critical_small.png").'"> Unable to find the required Nagios Core XML CGI.</span>';
			$error=true;
			}
		}
		
	// make sure we can parse XML
	if($error==false){
		// load xml
		$xml=simplexml_load_string($tac_data["body"]);
		if(!$xml){
			$output.='<span class="tacserverparseerror"><img src="'.theme_image("critical_small.png").'"> Unable to parse Nagios Core server response.</span>';
			$error=true;
			}
		}

	// ok to go
	if($error==false){
		//$output.=serialize($tac_data["body"]);
		//$output.="Nagios Core servers are not supported at this time.";

		//$output.="Good to go.";
		
		$sinfo=get_server_info($sid);
		$baseurl=$sinfo["url"];
		
		$output.='
		<table class="infotable tacsummary">
		<thead>
		<tr><th colspan="6">Status Summary&nbsp;</th><th nowrap>Notes <a href="'.get_base_url().'?fusionwindow=admin/servers.php%3Fedit%3D1%26server_id[]%3D'.urlencode($sid).'" target="_parent">[ Edit ]</a></th></tr>
		</thead>
		<tbody>
		';
		
		$output.='<tr>';
		$output.='<th>Hosts</th>';
		$output.=get_nagioscore_tac_host_status_td($xml,"up","Up",$baseurl);
		$output.=get_nagioscore_tac_host_status_td($xml,"down","Down",$baseurl);
		$output.=get_nagioscore_tac_host_status_td($xml,"unreachable","Unreachable",$baseurl);
		$output.=get_nagioscore_tac_host_status_td($xml,"pending","Pending",$baseurl);
		
		$notes=str_replace("\n","<BR>",$sinfo["notes"]);
		
		$output.='<td>&nbsp;</td>';
		$output.='<td rowspan="3" valign="top">'.htmlentities($notes).'</td>';
		$output.='</tr>';
		
		$output.='<tr>';
		$output.='<th>Services</th>';
		$output.=get_nagioscore_tac_service_status_td($xml,"ok","Ok",$baseurl);
		$output.=get_nagioscore_tac_service_status_td($xml,"warning","Warning",$baseurl);
		$output.=get_nagioscore_tac_service_status_td($xml,"unknown","Unknown",$baseurl);
		$output.=get_nagioscore_tac_service_status_td($xml,"critical","Critical",$baseurl);
		$output.=get_nagioscore_tac_service_status_td($xml,"pending","Pending",$baseurl);
		$output.='</tr>';
			
		$output.='<tr>';
		$output.='<th>Settings</th>';
		$output.='<td colspan="5">';
		
		$output.=get_nagioscore_tac_setting_status($xml,"notifications","Notifications",1,$baseurl);
		$output.=get_nagioscore_tac_setting_status($xml,"activeservicechecks","Active Checks",2,$baseurl);
		$output.=get_nagioscore_tac_setting_status($xml,"passiveservicechecks","Passive Checks",0,$baseurl);
		$output.=get_nagioscore_tac_setting_status($xml,"eventhandlers","Event Handlers",0,$baseurl);
		
		$output.='</td>';
		$output.='</tr>';

		$output.='
		</tbody>
		</table>
		';		
		
		
		}

	return $output;
	}
	
function get_nagioscore_tac_setting_status($xml,$shortname,$longname,$disabledstate,$baseurl){

	$output="";
	
	$gotourl=$baseurl."/?corewindow=cgi-bin/extinfo.cgi%3Ftype%3D0";
	
	
	$val=intval($xml->monitoringfeaturestatus->$shortname->global);
	
	$statetext="";
	$class="";
	if($val==0){
		$statetext="Disabled";
		switch($disabledstate){
			case 2:
				$class="settingcritical";
				break;
			case 1:
				$class="settingwarning";
				break;
			default:
				$class="settingok";
				break;
			}
		}
	else{
		$statetext="Enabled";
		$class="settingok";
		}

	$output.="<span class='settingstatus ".$class."'><a href='".$gotourl."' target='_blank'>".$longname.": ".$statetext."</a></span>";

	return $output;
	}
	
function get_nagioscore_tac_host_status_td($xml,$shortstate,$statename,$baseurl){

//	$gotourl=$baseurl."/?xiwindow=includes/components/xicore/status.php%3Fshow%3Dhosts%26servicestatustypes%3D0%26hoststatustypes%3D1";
//	$gotourl=$baseurl;
	$gotourl=$baseurl."/?corewindow=cgi-bin/status.cgi%3Fhostgroup%3Dall%26style%3Dhostdetail%26hoststatustypes%3D";
	
	switch($shortstate){
		case "up":
			$gotourl.="2";
			break;
		case "down":
			$gotourl.="4";
			break;
		case "unreachable":
			$gotourl.="8";
			break;
		case "pending":
			$gotourl.="1";
			break;
		}

	$output="";
	
	$total=intval($xml->hoststatustotals->$shortstate->total);
	
	$baseclass="hoststatus".$shortstate;
	$extraclass="";
	if($total>0)
		$extraclass=" ".$baseclass."-present";
	
	$output.="<td nowrap valign='top' class='".$baseclass.$extraclass."'>";

	//$output.="<span class='".$baseclass.$extraclass."'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";
	$output.="<span class='total'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";

	if($shortstate!="ok" && $shortstate!="pending"){

		// unhandled problems
		$total=intval($xml->hoststatustotals->$shortstate->unhandled);
		if($total>0)
			$output.="<span class='substatus unhandled'><a href='".$gotourl."%26hostprops%3D42' target='_blank'>".$total." Unhandled</a></span>";
		
		// acknowledged
		$total=intval($xml->hoststatustotals->$shortstate->acknowledged);
		if($total>0)
			$output.="<span class='substatus acknowledged'><a href='".$gotourl."%26hostprops%3D4' target='_blank'>".$total." Acknowledged</a></span>";
		
		// scheduled downtime
		$total=intval($xml->hoststatustotals->$shortstate->scheduleddowntime);
		if($total>0)
			$output.="<span class='substatus scheduleddowntime'><a href='".$gotourl."%26hostprops%3D1' target='_blank'>".$total." Scheduled</a></span>";
		}
	
	// disabled
	$total=intval($xml->hoststatustotals->$shortstate->disabled);
	if($total>0)
		$output.="<span class='substatus disabled'><a href='".$gotourl."%26hostprops%3D16' target='_blank'>".$total." Disabled</a></span>";
	

	$output.="</td>";
	
	return $output;
	}

function get_nagioscore_tac_service_status_td($xml,$shortstate,$statename,$baseurl){

//	$gotourl=$baseurl;
	$gotourl=$baseurl."/?corewindow=cgi-bin/status.cgi%3Fhost%3Dall%26servicestatustypes%3D";
	
	switch($shortstate){
		case "ok":
			$gotourl.="2";
			break;
		case "warning":
			$gotourl.="4";
			break;
		case "unknown":
			$gotourl.="8";
			break;
		case "critical":
			$gotourl.="16";
			break;
		case "pending":
			$gotourl.="1";
			break;
		}

	$output="";
	
	$total=intval($xml->servicestatustotals->$shortstate->total);
	
	$baseclass="servicestatus".$shortstate;
	$extraclass="";
	if($total>0)
		$extraclass=" ".$baseclass."-present";
	
	$output.="<td valign='top' nowrap class='".$baseclass.$extraclass."'>";
	
	//$output.="<span class='".$baseclass.$extraclass."'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";
	$output.="<span class='total'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";

	if($shortstate!="ok" && $shortstate!="pending"){

		// unhandled problems
		$total=intval($xml->servicestatustotals->$shortstate->unhandled);
		if($total>0)
			$output.="<span class='substatus unhandled'><a href='".$gotourl."%26hoststatustypes%3D3%26serviceprops%3D42' target='_blank'>".$total." Unhandled</a></span>";
		
		// acknowledged
		$total=intval($xml->servicestatustotals->$shortstate->acknowledged);
		if($total>0)
			$output.="<span class='substatus acknowledged'><a href='".$gotourl."%26serviceprops%3D4' target='_blank'>".$total." Acknowledged</a></span>";
		
		// scheduled downtime
		$total=intval($xml->servicestatustotals->$shortstate->scheduleddowntime);
		if($total>0)
			$output.="<span class='substatus scheduleddowntime'><a href='".$gotourl."%26serviceprops%3D1' target='_blank'>".$total." Scheduled</a></span>";
		
		// problem hosts
		$total=intval($xml->servicestatustotals->$shortstate->hostproblem);
		if($total>0)
			$output.="<span class='substatus hostproblem'><a href='".$gotourl."%26hoststatustypes%3D12' target='_blank'>".$total." On Problem Hosts</a></span>";
		}
	
	// disabled
	$total=intval($xml->servicestatustotals->$shortstate->disabled);
	if($total>0)
		$output.="<span class='substatus disabled'><a href='".$gotourl."%26serviceprops%3D16' target='_blank'>".$total." Disabled</a></span>";
	
	
	$output.="</td>";
	
	return $output;
	}

	
function get_nagiosxi_tac_overview_data($sid,$username,$password){
	
	$output="";
	
	///////////////////////////////////////
	// get host status data
	///////////////////////////////////////
	$host_data=array();
	get_server_data($sid,$username,$password,"hoststatus",$host_data);
	
	// check for errors...
	$error=false;
	
	// check for timeout
	if($host_data["timeout"]==true){
		$output.='<span class="tacservertimeout"><img src="'.theme_image("critical_small.png").'"> A timeout occurred while attempting to contact the server.</span>';
		$error=true;
		}
		
	// check for auth error
	if($error==false){
		if($host_data["http_code"]==401){
			$output.='<span class="tacserverautherror"><img src="'.theme_image("critical_small.png").'"> Failed to authenticate to server.  <a href="'.get_base_url().'config/" target="_top">Change credentials</a>.</span>';
			$error=true;
			}
		}

	// make sure we can parse XML
	if($error==false){
		// load xml
		$hxml=@simplexml_load_string($host_data["body"]);
		if(!$hxml){
			$output.='<span class="tacserverparseerror"><img src="'.theme_image("critical_small.png").'"> Unable to parse Nagios XI server response.</span>';
			$error=true;
			}
		}
			
	///////////////////////////////////////
	// get service status data
	///////////////////////////////////////
	if($error==false){

		$service_data=array();
		get_server_data($sid,$username,$password,"servicestatus",$service_data);
		
		// check for errors...
		$error=false;
		
		// check for timeout
		if($service_data["timeout"]==true){
			$output.='<span class="tacservertimeout"><img src="'.theme_image("critical_small.png").'"> A timeout occurred while attempting to contact the server.</span>';
			$error=true;
			}
		}
		
	// make sure we can parse XML
	if($error==false){
		// load xml
		$sxml=@simplexml_load_string($service_data["body"]);
		if(!$sxml){
			$output.='<span class="tacserverparseerror"><img src="'.theme_image("critical_small.png").'"> Unable to parse server response.</span>';
			$error=true;
			}
		}
		
	// okay to go
	if($error==false){
		
		// combine host/service xml data
		$xml=get_nagiosxi_server_tac_stats($hxml,$sxml);
			
		$sinfo=get_server_info($sid);
		$baseurl=$sinfo["url"];
		
		$output.='
		<table class="infotable tacsummary">
		<thead>
		<tr><th colspan="6">Status Summary&nbsp;</th><th nowrap>Notes <a href="'.get_base_url().'?fusionwindow=admin/servers.php%3Fedit%3D1%26server_id[]%3D'.urlencode($sid).'" target="_parent">[ Edit ]</a></th></tr>
		</thead>
		<tbody>
		';
		
		$output.='<tr>';
		$output.='<th>Hosts</th>';
		$output.=get_nagiosxi_tac_host_status_td($xml,"up","Up",$baseurl);
		$output.=get_nagiosxi_tac_host_status_td($xml,"down","Down",$baseurl);
		$output.=get_nagiosxi_tac_host_status_td($xml,"unreachable","Unreachable",$baseurl);
		$output.=get_nagiosxi_tac_host_status_td($xml,"pending","Pending",$baseurl);
		
		$notes=str_replace("\n","<BR>",$sinfo["notes"]);
		
		//$output.='<td>&nbsp;</td>';
		$output.='<td>'.embed_nagiosxi_magic_login($sid).'</td>';
		$output.='<td rowspan="2" valign="top">'.$notes.'</td>';
		$output.='</tr>';
		
		$output.='<tr>';
		$output.='<th>Services</th>';
		$output.=get_nagiosxi_tac_service_status_td($xml,"ok","Ok",$baseurl);
		$output.=get_nagiosxi_tac_service_status_td($xml,"warning","Warning",$baseurl);
		$output.=get_nagiosxi_tac_service_status_td($xml,"unknown","Unknown",$baseurl);
		$output.=get_nagiosxi_tac_service_status_td($xml,"critical","Critical",$baseurl);
		$output.=get_nagiosxi_tac_service_status_td($xml,"pending","Pending",$baseurl);
		$output.='</tr>';
			
		$settings_data=array();
		get_server_data($sid,$username,$password,"programstatus",$settings_data);
		$settingsxml=@simplexml_load_string($settings_data["body"]);

		$output.='<tr>';
		$output.='<th>Settings</th>';
		$output.='<td colspan="5">';
		
		if($settingsxml){
		
			//print_r($settingsxml);
		
			$output.=get_nagiosxi_tac_setting_status($settingsxml,"is_currently_running","Monitoring Engine",2,$baseurl);
			$output.=get_nagiosxi_tac_setting_status($settingsxml,"notifications_enabled","Notifications",1,$baseurl);
			$output.=get_nagiosxi_tac_setting_status($settingsxml,"active_service_checks_enabled","Active Checks",2,$baseurl);
			$output.=get_nagiosxi_tac_setting_status($settingsxml,"passive_service_checks_enabled","Passive Checks",0,$baseurl);
			$output.=get_nagiosxi_tac_setting_status($settingsxml,"event_handlers_enabled","Event Handlers",0,$baseurl);
			}
		
		$output.='</td>';
		$output.='</tr>';

		$output.='
		</tbody>
		</table>
		';		
		
		}	
	
	return $output;
	}

	
function get_nagiosxi_tac_setting_status($xml,$shortname,$longname,$disabledstate,$baseurl){

	$output="";
	
	$gotourl=$baseurl."/?xiwindow=admin/sysstat.php%3Fpageopt%3Dmonitoringengine";
	
	
	$val=intval($xml->programstatus->$shortname);
	
	$statetext="";
	$class="";
	if($val==0){
		$statetext="Disabled";
		switch($disabledstate){
			case 2:
				$class="settingcritical";
				break;
			case 1:
				$class="settingwarning";
				break;
			default:
				$class="settingok";
				break;
			}
		}
	else{
		$statetext="Enabled";
		$class="settingok";
		}

	$output.="<span class='settingstatus ".$class."'><a href='".$gotourl."' target='_blank'>".$longname.": ".$statetext."</a></span>";

	return $output;
	}
	
function get_nagiosxi_tac_host_status_td($xml,$shortstate,$statename,$baseurl){

	$gotourl=$baseurl."/?xiwindow=includes/components/xicore/status.php%3Fshow%3Dhosts%26servicestatustypes%3D0%26hoststatustypes%3D";
	
	switch($shortstate){
		case "up":
			$gotourl.="2";
			break;
		case "down":
			$gotourl.="4";
			break;
		case "unreachable":
			$gotourl.="8";
			break;
		case "pending":
			$gotourl.="1";
			break;
		}

	$output="";
	
	$total=intval($xml->hoststatustotals->$shortstate->total);
	
	$baseclass="hoststatus".$shortstate;
	$extraclass="";
	if($total>0)
		$extraclass=" ".$baseclass."-present";
	
	$output.="<td nowrap valign='top' class='".$baseclass.$extraclass."'>";

	//$output.="<span class='".$baseclass.$extraclass."'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";
	$output.="<span class='total'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";

	if($shortstate!="ok" && $shortstate!="pending"){

		// unhandled problems
		$total=intval($xml->hoststatustotals->$shortstate->unhandled);
		if($total>0)
			$output.="<span class='substatus unhandled'><a href='".$gotourl."%26hostattr%3D42' target='_blank'>".$total." Unhandled</a></span>";
		
		// acknowledged
		$total=intval($xml->hoststatustotals->$shortstate->acknowledged);
		if($total>0)
			$output.="<span class='substatus acknowledged'><a href='".$gotourl."%26hostattr%3D4' target='_blank'>".$total." Acknowledged</a></span>";
		
		// scheduled downtime
		$total=intval($xml->hoststatustotals->$shortstate->scheduleddowntime);
		if($total>0)
			$output.="<span class='substatus scheduleddowntime'><a href='".$gotourl."%26hostattr%3D1' target='_blank'>".$total." Scheduled</a></span>";
		}
	
	// disabled
	$total=intval($xml->hoststatustotals->$shortstate->disabled);
	if($total>0)
		$output.="<span class='substatus disabled'><a href='".$gotourl."%26hostattr%3D16' target='_blank'>".$total." Disabled</a></span>";
	

	$output.="</td>";
	
	return $output;
	}

function get_nagiosxi_tac_service_status_td($xml,$shortstate,$statename,$baseurl){

	$gotourl=$baseurl."/?xiwindow=includes/components/xicore/status.php%3Fshow%3Dservices%26servicestatustypes%3D";
	
	switch($shortstate){
		case "ok":
			$gotourl.="2";
			break;
		case "warning":
			$gotourl.="4";
			break;
		case "unknown":
			$gotourl.="8";
			break;
		case "critical":
			$gotourl.="16";
			break;
		case "pending":
			$gotourl.="1";
			break;
		}

	$output="";
	
	$total=intval($xml->servicestatustotals->$shortstate->total);
	
	$baseclass="servicestatus".$shortstate;
	$extraclass="";
	if($total>0)
		$extraclass=" ".$baseclass."-present";
	
	$output.="<td valign='top' nowrap class='".$baseclass.$extraclass."'>";
	
	//$output.="<span class='".$baseclass.$extraclass."'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";
	$output.="<span class='total'><a href='".$gotourl."' target='_blank'>".$total." ".$statename."</a></span>";

	if($shortstate!="ok" && $shortstate!="pending"){

		// unhandled problems
		$total=intval($xml->servicestatustotals->$shortstate->unhandled);
		if($total>0)
			$output.="<span class='substatus unhandled'><a href='".$gotourl."%26hoststatustypes%3D3%26serviceattr%3D42' target='_blank'>".$total." Unhandled</a></span>";
		
		// acknowledged
		$total=intval($xml->servicestatustotals->$shortstate->acknowledged);
		if($total>0)
			$output.="<span class='substatus acknowledged'><a href='".$gotourl."%26serviceattr%3D4' target='_blank'>".$total." Acknowledged</a></span>";
		
		// scheduled downtime
		$total=intval($xml->servicestatustotals->$shortstate->scheduleddowntime);
		if($total>0)
			$output.="<span class='substatus scheduleddowntime'><a href='".$gotourl."%26serviceattr%3D1' target='_blank'>".$total." Scheduled</a></span>";
		
		// problem hosts
		$total=intval($xml->servicestatustotals->$shortstate->hostproblem);
		if($total>0)
			$output.="<span class='substatus hostproblem'><a href='".$gotourl."%26hoststatustypes%3D12' target='_blank'>".$total." On Problem Hosts</a></span>";
		}
	
	// disabled
	$total=intval($xml->servicestatustotals->$shortstate->disabled);
	if($total>0)
		$output.="<span class='substatus disabled'><a href='".$gotourl."%26serviceattr%3D16' target='_blank'>".$total." Disabled</a></span>";
	
	
	$output.="</td>";
	
	return $output;
	}

function get_nagiosxi_server_tac_stats($xmlh,$xmls){
	$hosts_up_disabled=0;
	$hosts_up_total=0;
	$hosts_down_disabled=0;
	$hosts_down_scheduled=0;
	$hosts_down_acknowledged=0;
	$hosts_down_unhandled=0;
	$hosts_down_total=0;
	$hosts_unreachable_disabled=0;
	$hosts_unreachable_scheduled=0;
	$hosts_unreachable_acknowledged=0;
	$hosts_unreachable_unhandled=0;
	$hosts_unreachable_total=0;
	$hosts_pending_disabled=0;
	$hosts_pending_total=0;
	
	$services_ok_disabled=0;
	$services_ok_total=0;
	$services_pending_disabled=0;
	$services_pending_total=0;
	$services_warning_total=0;
	$services_warning_disabled=0;
	$services_warning_acknowledged=0;
	$services_warning_scheduled=0;
	$services_warning_hostproblem=0;
	$services_warning_unhandled=0;
	$services_critical_total=0;
	$services_critical_disabled=0;
	$services_critical_acknowledged=0;
	$services_critical_scheduled=0;
	$services_critical_hostproblem=0;
	$services_critical_unhandled=0;
	$services_unknown_total=0;
	$services_unknown_disabled=0;
	$services_unknown_acknowledged=0;
	$services_unknown_scheduled=0;
	$services_unknown_hostproblem=0;
	$services_unknown_unhandled=0;
	
	$problem=false;
	
	foreach($xmls->servicestatus as $ss){

		$state=intval($ss->current_state);
		$hbc=intval($ss->has_been_checked);
		$active_checks=intval($ss->active_checks_enabled);
		$flapping=intval($ss->is_flapping);
		$downtime=intval($ss->scheduled_downtime_depth);
		$ack=intval($ss->problem_acknowledged);
		$hoststate=intval($ss->host_current_state);
		
		// fake pending state
		if($hbc==0)
			$state=-1;
			
		switch($state){
			case 0:
				$services_ok_total++;
				if($active_checks!=1)
					$services_ok_disabled++;
				break;
			case 1:
				$problem=true;
				$services_warning_total++;
				if($active_checks!=1){
					$services_warning_disabled++;
					$problem=false;
					}
				if($downtime>0){
					$services_warning_scheduled++;
					$problem=false;
					}
				if($ack==1){
					$services_warning_acknowledged++;
					$problem=false;
					}
				if($hoststate!=0){
					$services_warning_hostproblem++;
					$problem=false;
					}
				if($problem==true)
					$services_warning_unhandled++;
				break;
			case 2:
				$problem=true;
				$services_critical_total++;
				if($active_checks!=1){
					$services_critical_disabled++;
					$problem=false;
					}
				if($downtime>0){
					$services_critical_scheduled++;
					$problem=false;
					}
				if($ack==1){
					$services_critical_acknowledged++;
					$problem=false;
					}
				if($hoststate!=0){
					$services_critical_hostproblem++;
					$problem=false;
					}
				if($problem==true)
					$services_critical_unhandled++;
				break;
			case 3:
				$problem=true;
				$services_unknown_total++;
				if($active_checks!=1){
					$services_unknown_disabled++;
					$problem=false;
					}
				if($downtime>0){
					$services_unknown_scheduled++;
					$problem=false;
					}
				if($ack==1){
					$services_unknown_acknowledged++;
					$problem=false;
					}
				if($hoststate!=0){
					$services_unknown_hostproblem++;
					$problem=false;
					}
				if($problem==true)
					$services_unknown_unhandled++;
				break;
			case -1:
				$services_pending_total++;
				if($active_checks!=1)
					$services_pending_disabled++;
				break;
			default:
				break;
			}
		
		}
	
	foreach($xmlh->hoststatus as $hs){
	
		$state=intval($hs->current_state);
		$hbc=intval($hs->has_been_checked);
		$active_checks=intval($hs->active_checks_enabled);
		$flapping=intval($hs->is_flapping);
		$downtime=intval($hs->scheduled_downtime_depth);
		$ack=intval($hs->problem_acknowledged);
		
		
		// fake pending state
		if($hbc==0)
			$state=-1;
		
		switch($state){
			case 0:
				$hosts_up_total++;
				if($active_checks!=1)
					$hosts_up_disabled++;
				break;
			case 1:
				$problem=true;
				$hosts_down_total++;
				if($active_checks!=1){
					$hosts_down_disabled++;
					$problem=false;
					}
				if($downtime>0){
					$hosts_down_scheduled++;
					$problem=false;
					}
				if($ack==1){
					$hosts_down_acknowledged++;
					$problem=false;
					}
				if($problem==true)
					$hosts_down_unhandled++;
				break;
			case 2:
				$problem=true;
				$hosts_unreachable_total++;
				if($active_checks!=1){
					$hosts_unreachable_disabled++;
					$problem=false;
					}
				if($downtime>0){
					$hosts_unreachable_scheduled++;
					$problem=false;
					}
				if($ack==1){
					$hosts_unreachable_acknowledged++;
					$problem=false;
					}
				if($problem==true)
					$hosts_unreachable_unhandled++;
				break;
			case -1:
				$hosts_pending_total++;
				if($active_checks!=1)
					$hosts_pending_disabled++;
				break;
			default:
				break;
			}
		}

		
	$xstr="<tacinfo>";
	
	$xstr.="<hoststatustotals>";

	$xstr.="<unreachable><total>".$hosts_unreachable_total."</total><disabled>".$hosts_unreachable_disabled."</disabled><unhandled>".$hosts_unreachable_unhandled."</unhandled><scheduleddowntime>".$hosts_unreachable_scheduled."</scheduleddowntime><acknowledged>".$hosts_unreachable_acknowledged."</acknowledged></unreachable>";

	$xstr.="<down><total>".$hosts_down_total."</total><disabled>".$hosts_down_disabled."</disabled><unhandled>".$hosts_down_unhandled."</unhandled><scheduleddowntime>".$hosts_down_scheduled."</scheduleddowntime><acknowledged>".$hosts_down_acknowledged."</acknowledged></down>";

	$xstr.="<up><total>".$hosts_up_total."</total><disabled>".$hosts_up_disabled."</disabled></up>";

	$xstr.="<pending><total>".$hosts_pending_total."</total><disabled>".$hosts_pending_disabled."</disabled></pending>";
	
	$xstr.="</hoststatustotals>";
	
	$xstr.="<servicestatustotals>";
	
	$xstr.="<ok><total>".$services_ok_total."</total><disabled>".$services_ok_disabled."</disabled></ok>";
	
	$xstr.="<warning><total>".$services_warning_total."</total><disabled>".$services_warning_disabled."</disabled><unhandled>".$services_warning_unhandled."</unhandled><scheduleddowntime>".$services_warning_scheduled."</scheduleddowntime><acknowledged>".$services_warning_acknowledged."</acknowledged><hostproblem>".$services_warning_hostproblem."</hostproblem></warning>";

	$xstr.="<unknown><total>".$services_unknown_total."</total><disabled>".$services_unknown_disabled."</disabled><unhandled>".$services_unknown_unhandled."</unhandled><scheduleddowntime>".$services_unknown_scheduled."</scheduleddowntime><acknowledged>".$services_unknown_acknowledged."</acknowledged><hostproblem>".$services_unknown_hostproblem."</hostproblem></unknown>";

	$xstr.="<critical><total>".$services_critical_total."</total><disabled>".$services_critical_disabled."</disabled><unhandled>".$services_critical_unhandled."</unhandled><scheduleddowntime>".$services_critical_scheduled."</scheduleddowntime><acknowledged>".$services_critical_acknowledged."</acknowledged><hostproblem>".$services_critical_hostproblem."</hostproblem></critical>";

	$xstr.="<pending><total>".$services_pending_total."</total><disabled>".$services_pending_disabled."</disabled></pending>";
	
	$xstr.="</servicestatustotals>";
	
	$xstr.="</tacinfo>";
		
	$xml=simplexml_load_string($xstr);
	
	return $xml;
	}
	
?>